/*
Esercizio 1
Scrivere un programma che legga da tastiera una sequenza di n interi DISTINTI
e li inserisca in una tabella hash di dimensione 2n posizioni utilizzando
liste monodirezionali per risolvere eventuali conflitti. 

Utilizzare la funzione hash h(x) = ((ax + b) % p) % 2n dove p e' il numero primo 999149 e
a e b sono interi positivi minori di 100 scelti casualmente. Una volta inseriti
tutti gli interi, il programma deve stampare il numero totale di conflitti e la
lunghezza massima delle liste.

L’input e' formattato nel seguente modo: nella prima riga si trova la lunghezza
della sequenza e nelle successive si trovano gli interi che compongono la se-
quenza.
*/


#include <stdlib.h>
#include <stdio.h>

#define P (999149) 
#define CARICO (2)

int A, B; // A e B dichiarate qui sono visibili ad ogni funzione 

typedef struct _Nodo {

   int key;
   struct _Nodo *succ;
} Nodo;

typedef Nodo* Lista;

/* Inserisce il valore nella tabella hash di dimensione dim
 * Si utilizza la funzione hash h(valore) = ((A*valore + B) mod P) mod dim 
 * e si risolvono i conflitti utilizzando le liste
 */

void inserisci_elemento(Lista *tabella, int dim, int valore) {
 
  int ind_hash;
  Nodo *tmp;

  ind_hash = ((A*valore + B) % P) % dim;
  tmp = (Nodo *) malloc(sizeof(Nodo));
  if(tmp == NULL) exit(1);	
  tmp->key = valore;
  tmp->succ = tabella[ind_hash]; // punterà all'elemento successivo o a NULL
  tabella[ind_hash] = tmp;
}

int main() {

   Lista* tabella = NULL;
   int i, n, val, dimensione, valore;
   int conflitti = 0, maxlen = 0, num_elem; // Da utilizzare per calcolare le informazioni
   Nodo* testa;

   // Legge il numero di elementi 
   scanf("%d", &n);
   if(n < 1) return 1;

   srand( time(NULL) );
   A = rand()%(100-1)+1;;
   B = rand()%(100-1)+1;;
   // crea la tabella hash 

   dimensione = n * CARICO; // la dimensione della tabella
   tabella = (Lista*) malloc(dimensione * sizeof(Lista) );
   if(tabella == NULL) exit(1);

   for(i=0; i < dimensione; i++) 
	      tabella[i] = NULL; // ogni lista e' inizialmente vuota 

   // legge gli elementi e li inserisce nella lista
   for(i=0; i < n; i++) {
	scanf("%d", &valore);
	inserisci_elemento(tabella, dimensione, valore);
   }
   
   /* calcola le informazioni sulla tabella */
   for(i=0; i < dimensione; i++) {
      num_elem = 0;
      testa = (Nodo *)tabella[i];
      while(testa != NULL){ 
        num_elem++;
        testa = testa->succ;
      }

      if(maxlen < num_elem) maxlen = num_elem;
      if(num_elem > 1) conflitti += num_elem;
   }
  
   printf("Numero conflitti %d\n", conflitti);
   printf("Lunghezza massima %d\n", maxlen);
   return 0;

}
